.model small

.stack 256h


.data
    ; duomenu failas
    fdname db 255 dup (?)
    fdhandle dw 0
    ; rezultatu failas
    frname db 255 dup (?)
    frhandle dw 0
    ; spausidnimui naudojami masyvai
    newline db 13, 10, '$'
    error_message db 'Error',13,10,'$'
    helpCommand db '/?'
    help_message db 'Correct input is failai.exe <input.txt> <0-9> <output.txt>',13,10, '$'
    ; kintamieji
    remainder db 0
    char db ?
    num db ?
    ; skaitmenu kiekis atsakyme
    totalNumberSize dw 0
    ; skaitymo buferis
    fbuf db 100 dup (?)
    skaicius db 254 dup (?)
    rez db 255 dup (?)
    carryFlag db 0
    
    

.code

main proc 
    
    mov ax, @data
    mov ds, ax
    mov si, 0
    
    ; patikrina ar parasyta help komanda
    call checkHelp
    ;paima komandine eilute
    
    call getCommand 
    ;call testing
    
    ; sukuria rez.txt faila
    call createFile
    
    ;atidaro duom.txt ir rez.txt
    call openReadWrite
    
    ; skaiciavimai atliekami cia
    mov si, 0
    mov di, 0
    call calculate
    ;spausdinimas
    call output
    
    
    ; uzdaromi atidaryti .txt failai
    call closeReadWrite
    
    mov ax,4C00h
    int 21h



checkHelp proc
    
    mov si, 82h
    mov di, 0
    helpLoop:
    cmp di, 2
    jz help
    mov bl, es:[si]
    mov cl, helpCommand[di]
    inc si
    inc di
    cmp bl, cl
    jz  helpLoop
    jnz endHelpLoop
    help:
    
    mov ah, 09
    mov dx, offset help_message
    int 21h  
    
    endHelpLoop:
    
    ret         
checkHelp endp



getCommand proc
    mov si, 82h
    mov di, 0
    ;tiek simboliu yra is viso komandoj
    mov cl, es:[80h]
    dec cl

    fdLoopStart:
    mov dl, es:[si]
    
    ;tikrinu tarpa
    cmp dl, 32
    jz readNum
    ;tikrinu pabaiga
    cmp dl, 13
    jz badInput
    cmp dl, 0
    jz badInput
    mov fdname[di], dl

    dec cl
    inc si
    inc di
    jmp fdLoopStart
     
    readNum:
    inc si
    mov dl, es:[si]
    mov num, dl
     
    cmp num, 48
    jb badInput 
    cmp num, 57
    ja badInput
    sub num, 48
    

    inc si
    mov dl, es:[si]
    cmp dl, 32
    jnz badInput
    
    inc si
    mov di, 0
    jmp frLoopStart
    badInput:
    mov ah, 9
    mov dx, offset error_message
    int 21h

    mov ah, 09
    mov dx, offset help_message
    int 21h
    
    mov ax, 4C00h
    int 21h
    
    frLoopStart:
    mov dl, es:[si]
    cmp dl, 13
    jz endGetCommand
    mov dl, es:[si]
    mov frname[di], dl

    dec cl
    inc si
    inc di
    jmp frLoopStart
    
    endGetCommand: 
        
    ret
    
getCommand endp
    


createFile proc 
    ;sukuriu rez faila
    mov ax, 3C00h
    lea dx, frname          
    mov cx, 0               
    int 21h
    jc errorCreatingFile
    
    jmp endCreateFile
    
    errorCreatingFile:
    mov ah, 9
    mov dx, offset error_message
    int 21h
    
    mov ah, 09
    mov dx, offset help_message
    int 21h
    
    mov ax, 4C00h
    int 21h
    
    endCreateFile:
    ret
createFile endp

openReadWrite proc    
    ; failo atidarymas skaitymui
    mov ax, 3d00h
    lea dx, fdname
    int 21h
    jc errorOpeningFile
    
    mov fdhandle, ax
    ; failo atidarymas rasymui
    mov ax, 3d01h
    lea dx, frname
    int 21h
    jc errorOpeningFile
    mov frhandle, ax
    
    jmp endReadWrite
    
    errorOpeningFile:
    mov ah, 9
    mov dx, offset error_message
    int 21h
    
    mov ah, 09
    mov dx, offset help_message
    int 21h
    
    mov ax, 4C00h
    int 21h

    
    endReadWrite:
    ret
openReadWrite endp



calculate proc   
    
    cmp num, 0
    jz zero
   
    
    read:
    mov ah, 3fh
    lea dx, fbuf
    mov cx, 100
    mov bx, fdhandle[0]
    int 21h
    
    cmp ax, 0 
    jz calc
    mov ah, 0
    mov di, 0
   
    add totalNumberSize, ax
    copy:
    mov dl, fbuf[di]
    sub dl, 48
    mov skaicius[si], dl
    inc si
    inc di
    cmp di, ax
    jnz copy
    
    mov si, totalNumberSize
    jmp read
    
    
      
    calc:
    ; dl - ivestas skaicius, cl - failo skaicius
    cmp si, 0
    jz checkRemainder
    
    
    mov cl, num
    
    mov al, skaicius[si-1]
    mul cl
    mov cl, 10
    div cl ; ah- liekana, al - dalmuo
    add ah, remainder
    cmp ah, 10
    jge greaterThanTen
     
    continue:
    mov bx, 0
    mov bl, ah
    add bl, 48
    mov remainder, al

    mov skaicius[si], bl
    dec si
    
    
    jmp calc
    ; jeigu dauginamasis 0
    zero:
    mov ah, 40h
    mov char, '0'
    lea dx, char
    mov cx, 1
    mov bx, frhandle[0]
    int 21h
    call closeReadWrite
    
    ; jei pridejus praeita mod 10 gaunasi daugiau nei 10
    greaterThanTen:
    sub ah, 10
    inc al
    jmp continue
    
    ; jei pasibaigus dar yra liekana, tada ta liekana bus pirmas skaicius
    checkRemainder:
    cmp remainder, 0
    jz exitCalculate 
    jnz addLastDigit
    
    ;pridedamas pirmas skaicius jei uzsiliko liekana
    addLastDigit:
    mov bx, 0
    add remainder, 48
    mov bl, remainder
    mov skaicius[0], bl
    mov carryFlag, 1
    jmp exitCalculate
    
    
    
    exitCalculate:
    
    
    ret
    
calculate endp


output proc 
    mov si, 0
    
    cmp carryFlag, 0
    jz fromSecond
    jnz fromFirst
    
    fromFirst:
    mov ah, 40h
    lea dx, skaicius
    inc totalNumberSize
    mov cx, totalNumberSize
    mov bx, frhandle[0]
    int 21h
    jmp exit
    
    fromSecond:
    mov ah, 40h
    lea dx, skaicius[1]
    mov cx, totalNumberSize
    mov bx, frhandle[0]
    int 21h
    
    exit:
    
    ret
    
    cantOpenFile:
    mov ah, 9
    mov dx, offset error_message
    int 21h
   
    mov ah, 09
    mov dx, offset help_message
    int 21h
    
    mov ax, 4C00h
    int 21h 
    exit:
    
    ret
    
    
output endp


closeReadWrite proc
    ;uzdaromas duomenu failas
    mov ah, 3Eh
    mov bx, fdhandle[0]
    int 21h    
    jc cantCloseFile
    ;uzdaromas rezultatu failas
    mov ah, 3Eh
    mov bx, frhandle[0]
    int 21h
    jc cantCloseFile
    
    
    
    mov ax, 4C00h
    int 21h
    ret 
    
    cantCloseFile:
    mov ah, 9
    mov dx, offset error_message
    int 21h
  
    mov ah, 09
    mov dx, offset help_message
    int 21h
    
    mov ax, 4C00h
    int 21h
    
    
closeReadWrite endp
    

validateNumber proc 
    cmp dl, 9
    jg errorMessage
    cmp dl, 0
    jl errorMessage
    
    errorMessage:
    mov ah, 9
    mov dx, offset error_message
    int 21h
    
    mov ah, 09
    mov dx, offset help_message
    int 21h
    
    mov ax, 4C00h
    int 21h
    
    ret
validateNumber endp

    


endp
end main